/* global LayoutManager, utils, Logger */
(function() {
	"use strict";

	window.LayoutManager.flash = function (media, container, callback, layoutid, scheduleid, scp) {
		if (media.media.audio !== undefined) {
			var audio = {
					uri : "file:///opt/usr/home/owner/content/Downloads/" + media.media.audio[0].uri[0].jValue,
					loop : media.media.audio[0].uri[0].jAttr.loop,
					volume : media.media.audio[0].uri[0].jAttr.volume
			};
			this.audiooverlay = new LayoutManager.audioOverlay(audio, container);
			this.audiooverlay.preload(function(){
				parent.audiooverlay.play();
			}, null);
		}

		this.statsStartTime = utils.getISODate();
		this.duration = parseInt(media.duration);
		var duration = this.duration;
		this.uri = "file:///opt/usr/home/owner/content/Downloads/" + media.media.options[0].uri[0].jValue;
		this.elem = document.createElement("object");
		this.elem.style.position = "absolute";
		this.elem.style.left = 0;
		this.elem.style.top = 0;
		this.elem.style.width = "100%";
		this.elem.style.height = "100%";
		this.elem.style.overflow = "hidden";
		this.elem.style.border = "none";
		this.flash = document.createElement('param');
		this.flash.setAttribute('name', 'movie');
		this.flash.setAttribute('value', this.uri);
		this.transparency = document.createElement('param');
		this.transparency.setAttribute('name', 'wMode');
		this.transparency.setAttribute('value', 'transparent');
		this.elem.appendChild(this.flash);
		this.elem.appendChild(this.transparency);

		var parent = this;
		this.timeoutElement = null;
		this.removeMedia = function () { container.removeChild(this.elem); };
		var hastransIn = false;
		var hastransOut = false;
		var transInDuration = 1000;
		var transOutDuration = 1000;
		var transInType = null;
		var transOutType = null;
		var transInDirection = "S";
		var transOutDirection = "S";
		if (media.media.options[0].hasOwnProperty("transIn")){ hastransIn = true; transInType = media.media.options[0].transIn[0].jValue; transInDirection = media.media.options[0].transInDirection[0].jValue; }
		if (media.media.options[0].hasOwnProperty("transOut")){ hastransOut = true; transOutType = media.media.options[0].transOut[0].jValue; transOutDirection = media.media.options[0].transOutDirection[0].jValue; }
		if (media.media.options[0].hasOwnProperty("transInDuration")){ transInDuration = media.media.options[0].transInDuration[0].jValue; }
		if (media.media.options[0].hasOwnProperty("transOutDuration")){ transOutDuration = media.media.options[0].transOutDuration[0].jValue; }
		this.timeoutMedia = function () {
			//var tag = "r: " + container.getAttribute("id") + " m: " + media.id + " flash";
			parent.timeoutElement = setTimeout(function(){
				if (hastransOut) {
					LayoutManager.transout(parent.elem, container, transOutType, transOutDuration, transOutDirection, function() { 
						if (parent.audiooverlay){
							parent.audiooverlay.stop();
						}
						if (scheduleid){
	                        Logger.logStat({fromdt: parent.statsStartTime, todt: utils.getISODate(), scheduleid: scheduleid, layoutid: layoutid, mediaid:media.id});
	                    }
						callback();
					});
				} else {
					if (parent.audiooverlay){
						parent.audiooverlay.stop();
					}
					if (scheduleid){
                        Logger.logStat({fromdt: parent.statsStartTime, todt: utils.getISODate(), scheduleid: scheduleid, layoutid: layoutid, mediaid:media.id});
                    }
					callback();
				}
			}, duration * 1000, layoutid, scp);
		};
		var timeoutMediaInvoke = this.timeoutMedia;
		this.displayThisMedia = function () {
			if (hastransIn) { duration -= parseInt(transInDuration)/1000; utils.hide(this.elem); }
			if (hastransOut) { duration -= parseInt(transOutDuration)/1000; }
			if (duration < 0) { duration = 0; }
			container.innerHTML = null;
			container.appendChild(this.elem);
			if (hastransIn) {
				LayoutManager.transin(this.elem, container, transInType, transInDuration, transInDirection, function() {timeoutMediaInvoke(parent);});
			} else {
				timeoutMediaInvoke(parent);
			}
		};
		this.stopMediaTimeout = function () {
			if (parent.audiooverlay){
				parent.audiooverlay.stop();
			}
//			if (scheduleid){
//                Logger.logStat({fromdt: parent.statsStartTime, todt: utils.getISODate(), scheduleid: scheduleid, layoutid: layoutid, mediaid:media.id});
//            }
			clearTimeout(parent.timeoutElement);
		};
		utils.httpGetAsync(this.uri, function(contents){
			if (contents.indexOf("<!-- DURATION=") !== -1) {
				var parts = contents.split("<!-- DURATION=");
				var htmlduration = parseInt(parts[parts.length - 1]);
				if (htmlduration > 0) { duration = htmlduration; }
			}
			parent.displayThisMedia(parent);        
		}, function(errorCb){
			console.error(errorCb);
		});
	};
}());
