/* 
 * Tizen - Xibo | Native Video Module
 * 
 * This uses the AVPlay tizen module
 */

/* global LayoutManager, utils, Logger */
(function() {
	"use strict";

//	var validStates = {
//			open : ['NONE', 'ERROR'], //, 'IDLE'
//			prepare : ['IDLE'],
//			prepareAsync : ['IDLE'],
//			play : ['READY', 'PAUSED'],
//			pause : ['PLAYING'],
//			stop : ['READY', 'PLAYING', 'PAUSED'],
//			close : ['NONE', 'IDLE', 'READY', 'PLAYING', 'PAUSED', 'ERROR'],
//			setDisplayRect : ['IDLE', 'PLAYING', 'PAUSED'],
//			setListener : ['IDLE'],
//			setDisplayMethod : ['IDLE', 'READY', 'PLAYING', 'PAUSED'],
//			getStreamingProperty : ['PLAYING', 'PAUSED'],
//			setStreamingProperty : ['IDLE'],
//			setBufferingParam : ['IDLE'],
//			changeURL : ['IDLE', 'READY', 'PLAYING', 'PAUSED']
//	};
	
	window.LayoutManager.localvideo = function (media, container, callback, layoutid, scheduleid, scp) {
		if (media.media.audio !== undefined) {
			var audio = {
					uri : "file:///opt/usr/home/owner/content/Downloads/" + media.media.audio[0].uri[0].jValue,
					loop : media.media.audio[0].uri[0].jAttr.loop,
					volume : media.media.audio[0].uri[0].jAttr.volume
			};
			this.audiooverlay = new LayoutManager.audioOverlay(audio, container);
			this.audiooverlay.preload(function(){
				parent.audiooverlay.play();
			}, null);
		}

		this.statsStartTime = utils.getISODate();
		this.isready = false;
		this.uri = decodeURIComponent(media.media.options[0].uri[0].jValue);
		this.elem = document.createElement("object");
		this.elem.type = 'application/avplayer';
		this.duration = parseInt(media.duration) * 1000;
		var parent = this;
		var duration = this.duration;
		if (media.media.options[0].mute !== undefined) { 
			if (media.media.options[0].mute[0].jValue === '1') { 
				this.elem.setAttribute('muted',''); 
			}
		}
		this.elem.style.left = "0";
		this.elem.style.top = "0";
		this.elem.style.width = "100%";
		this.elem.style.height = "100%";
		if (media.media.options[0].scaleType !== undefined) {
			if (media.media.options[0].scaleType[0].jValue === "aspect") {
				this.elem.style.objectFit = "contain";
			} else if (media.media.options[0].scaleType[0].jValue === "stretch") {
				this.elem.style.objectFit = "fill";
			} else {
				this.elem.style.objectFit = "contain";
			}
		} else {
			this.elem.style.objectFit = "contain";
		}
		
		function endPlayingMedia(){
			if (hastransOut) {
				LayoutManager.transout(parent.elem, container, transOutType, transOutDuration, transOutDirection, function() {
					if (parent.audiooverlay){
						parent.audiooverlay.stop();
					}
					if (scheduleid){
                        Logger.logStat({fromdt: parent.statsStartTime, todt: utils.getISODate(), scheduleid: scheduleid, layoutid: layoutid, mediaid:media.id});
                    }
					callback(); 
				});
			} else {
				if (parent.audiooverlay){
					parent.audiooverlay.stop();
				}
				//console.log('LocalVideo expired!');
				player.close();
				if (scheduleid){
                    Logger.logStat({fromdt: parent.statsStartTime, todt: utils.getISODate(), scheduleid: scheduleid, layoutid: layoutid, mediaid:media.id});
                }
				callback();
			}
		}
		
		this.timeoutElement = null;
		this.timeoutMedia = function () {
			parent.timeoutElement = setTimeout(endPlayingMedia, duration, layoutid, scp);
		};
		var timeoutMediaInvoke = this.timeoutMedia;
		this.removeMedia = function () { container.removeChild(this.elem); };
		var hastransIn = false;
		var hastransOut = false;
		var transInDuration = 1000;
		var transOutDuration = 1000;
		var transInType = null;
		var transOutType = null;
		var transInDirection = "S";
		var transOutDirection = "S";
		if (media.media.options[0].hasOwnProperty("transIn")){ hastransIn = true; transInType = media.media.options[0].transIn[0].jValue; transInDirection = media.media.options[0].transInDirection[0].jValue; }
		if (media.media.options[0].hasOwnProperty("transOut")){ hastransOut = true; transOutType = media.media.options[0].transOut[0].jValue; transOutDirection = media.media.options[0].transOutDirection[0].jValue; }
		if (media.media.options[0].hasOwnProperty("transInDuration")){ transInDuration = media.media.options[0].transInDuration[0].jValue; }
		if (media.media.options[0].hasOwnProperty("transOutDuration")){ transOutDuration = media.media.options[0].transOutDuration[0].jValue; }
		this.displayThisMedia = function () {

			container.innerHTML = null;
			container.appendChild(this.elem);
			timeoutMediaInvoke(parent);
		};

	
		/**************************************************************************/
		var player, bandwidthInfo,bandwidthInfoTemp;
		try {
			player = webapis.avplay;
		} catch (e) {
			console.error(e);
			return;
		}
		
		//console.log('Localvideo uri:'+this.uri);
		var listener = {
			//jshint unused:false
			onbufferingstart: function() {
			},
			onbufferingprogress: function(percent) {
			},
			onbufferingcomplete: function() {
			},
			oncurrentplaytime: function(currentTime) {
			},
			onevent: function(eventType, eventData) {
			},
			onerror: function(eventType) {
				console.warn("event type error : " + eventType);
			},
			onsubtitlechange: function(duration, text, data3, data4) {
			},  
			ondrmevent: function(drmEvent, drmData) {
			},
			onstreamcompleted: function() {
				console.log("Stream Completed");
				player.stop();
				endPlayingMedia();
			}
			//jshint unused:true
		};
		

		/**************************************************************************/

		var play = function(url) {
			try {
				player.open(url);
				player.setListener(listener);
				var rect = container.getClientRects()[0];
	        	var x = Number.parseInt(rect.left);
	        	var y = Number.parseInt(rect.top);
	        	var w = Number.parseInt(rect.width);
	        	var h = Number.parseInt(rect.height);
				player.setDisplayRect(x, y, w, h);
//	        	player.setStreamingProperty('SET_MODE_4K', 'TRUE');
//	        	player.setStreamingProperty('ADAPTIVE_INFO', 'BITRATES=500~99000000|STARTBITRATE=AVERAGE');				
				player.prepare();
				parent.isready = true;
				parent.displayThisMedia();
				player.play();
			} catch (e) {
				Logger.cmsLog({
		            category:Logger.cmsLog.CATEGORY.ERROR, 
		            message:"Could not play LocalVideo: Widget ID "+media.id
		            	+" with name "+media.media.options[0].uri[0].jValue
		            	+" on Layout ID "+layoutid
		            	+", in Region ID "+container.id
		            	+" with error "+e.message,
		            layoutID: layoutid,
		            mediaID: media.id,
		            method:"play",
		            thread:"LayoutManager.localvideo",
		            onlyOnce:true
		        });
				endPlayingMedia();
			}
		};


		play(this.uri);
		
		
		
//		function getSafeState(){
//			try {
//				return player.getState();
//			} catch (e) {
//				console.warn(e);
//				return 'ERROR';
//			}
//		}
//		
//		
//		function prepareAsyncSuccessCb(){
//			console.info('Available bitrates: ' + player.getStreamingProperty ("AVAILABLE_BITRATE"));
//			console.info('Play avplay [state:'+getSafeState()+']!');
//			try {
//				player.play();
//		    } catch (e) {
//		    	console.warn(e);
//	        }
//		}
//		
//		function prepareAsyncFailureCb(e){
//			console.warn(e);
//			return;
//		}
//		
//		try {
//			//To be called in this state - "NONE"
//			if (validStates.open.indexOf(getSafeState()) > -1){ 
//				console.info('Open AVPlay [state:'+getSafeState()+']!');
//				player.open(this.uri);
//			}else{
//				console.info('Change URL on AVPlay [state:'+getSafeState()+']!');
//				//player.stop();
//				player.restore(this.uri);
//			}
//        } catch (e) {
//            console.warn(e);
//            if (e.message === 'PLAYER_ERROR_INVALID_OPERATION'){
//            	try {
//    				console.warn('Stop and change URL on AVPlay failed.\nClose and open!');
//            		player.close();
//            		player.open(this.uri);
//            	} catch (e) {
//            		console.warn(e);
//            	}
//            }
//        }
//
//        //To be called in this state - "IDLE"
//		if (validStates.setListener.indexOf(getSafeState()) > -1){
//			console.info('Set AVPlay listener [state:'+getSafeState()+']!');
//			player.setListener(listener);
//		}
//		
//		
//        try {
//        	//To be called in these states - "IDLE", "PAUSE"
//        	if (validStates.setDisplayRect.indexOf(getSafeState()) > -1){
//	        	var rect = container.getClientRects()[0];
//	        	var x = Number.parseInt(rect.left);
//	        	var y = Number.parseInt(rect.top);
//	        	var w = Number.parseInt(rect.width);
//	        	var h = Number.parseInt(rect.height);
//				console.info('Set AVPlay display rectangle [state:'+getSafeState()+']!');
//				player.setDisplayRect(x, y, w, h);
//        	}
//        } catch (e) {
//        	console.warn(e);
//        }
//
//        if (validStates.setStreamingProperty.indexOf(getSafeState()) > -1){
//        	console.info('Set AVPlay Streaming properties [state:'+getSafeState()+']!');
//        	//player.setStreamingProperty('PREBUFFER_MODE', 'TRUE');
//        	player.setStreamingProperty('SET_MODE_4K', 'TRUE');
//        	player.setStreamingProperty('ADAPTIVE_INFO', 'BITRATES=500~99000000|STARTBITRATE=AVERAGE');
//        }
//
//        
//		//To be called in this state - "IDLE"
//        if (validStates.prepareAsync.indexOf(getSafeState()) > -1){
//            console.info('Prepare avplay [state:'+getSafeState()+']!');
//            try {
//            	player.prepareAsync(prepareAsyncSuccessCb, prepareAsyncFailureCb);
//            	bufferTimeOut = setTimeout(function(){
//            		console.warn('Not buffering for 10 seconds [state:'+getSafeState()+'].');
//            		clearTimeout(parent.timeoutElement);
//    				parent.isready = true;
//            		callback();
//            	},10000);
//            } catch (e) {
//            	console.warn(e);
//            	return;
//            }
//        }
		//timeoutMediaInvoke(parent);

//        try {
//        	if (avplayState === 'IDLE'){
//                console.info('Prepare avplay!');
//	        	webapis.avplay.prepare();
//        	}
//            prepareAsyncSuccessCb();
//            console.info('Timeout invoke!');
//    		timeoutMediaInvoke(parent);
//        } catch (e) {
//        	console.warn(e);
//        	callback();
//        	return;
//        }

		
//		function playNonRtspUdpRtpvideo(){
//			var xhr = new XMLHttpRequest();
//
//			xhr.onreadystatechange = function(){
//				if (xhr.readyState === 4){
//					if ((xhr.status === 404) || (xhr.status === 401) || (xhrerror)) {
//						parent.elem = document.createElement("span");
//						parent.elem.style.padding = "10px";
//						parent.elem.style.fontSize = "20px";
//						parent.elem.style.backgroundColor = "black";
//						parent.elem.style.color = "white";
//						parent.elem.innerHTML = "LocalVideo file " + parent.uri + " could not be loaded";
//						utils.empty(container);
//						container.appendChild(parent.elem);
//						parent.displayThisMedia(parent);
//					} else {
//						console.debug("Video Duration: " + parent.elem.children[0].duration);
//						if (duration === 0) {
//							duration = parent.elem.children[0].duration * 1000;
//						}
//						if (hastransIn) { duration -= parseInt(transInDuration); }
//						if (hastransOut) { duration -= parseInt(transOutDuration); }     
//						if (duration < 0) { duration = 0; }
//						//parent.elem.play();
//						console.debug("Duration: " + duration);
//						if (hastransIn) {
//							LayoutManager.transin(parent.elem, container, transInType, transInDuration, transInDirection, function() {timeoutMediaInvoke(parent);});
//						} else {
//							parent.displayThisMedia(parent);
//						}
//					}
//				}
//			};
//			
//			xhr.open('HEAD', parent.uri, true);
//			var xhrerror = false;
//			try {
//				xhr.send();
//			} catch (err) {
//				console.warn(err);
//				xhrerror = true;
//			}
//		};
//		
//		if ((mediatype === "rtsp") || (mediatype === "udp") || (mediatype === "rtp")) {
//			utils.empty(this.elem);
//			this.elem.setAttribute('preload','metadata');
//			var mediacodec = "mp4";
//			var options = {};
//			options.htmlMediaOption= {};
//			options.htmlMediaOption.useUMSMediaInfo = true;
//			var source = document.createElement("source");
//			var protocolType = mediatype;
//
//			if ( "udp" === protocolType ) { options.mediaTransportType = "UDP"; }
//			else if ( "rtp" === protocolType ) { options.mediaTransportType = "RTP"; }
//			else if ( "rtsp" === protocolType) { options.mediaTransportType = "RTSP"; }
//
//			source.setAttribute('src', this.uri); 
//
//			if ("mpegts" === mediacodec) {
//				source.setAttribute('type','video/' + mediacodec + ';mediaOption=' + escape(JSON.stringify(options)));
//			} else if (("mp4" === mediacodec) || ("mp2t" === mediacodec)) {
//				source.setAttribute('type','video/' + mediacodec + ';mediaOption=' + escape(JSON.stringify(options)));
//			}
//
//			utils.empty(container);
//			if (hastransIn) {
//				utils.hide(this.elem);
//			}
//			this.elem.appendChild(source);
//			container.appendChild(this.elem);
//			this.elem.load();
//			this.elem.play();
//			timeoutMediaInvoke(parent);
//
//			if (hastransIn) {
//				LayoutManager.transin(parent.elem, container, transInType, transInDuration, transInDirection, function() {timeoutMediaInvoke(parent);});
//			} else {
//				//parent.displayThisMedia(parent);
//			}
//		} else {
//			playNonRtspUdpRtpvideo();
//		}

		//this.elem.load();
		this.stopMediaTimeout = function () {
			console.debug("Timeout for " + media.id + " cleared!");
			if (parent.audiooverlay){
				parent.audiooverlay.stop();
			}
//			if (scheduleid){
//                Logger.logStat({fromdt: parent.statsStartTime, todt: utils.getISODate(), scheduleid: scheduleid, layoutid: layoutid, mediaid:media.id});
//            }
			clearTimeout(parent.timeoutElement);
		};  
	};
}());
