/* global utils */
(function() {
	"use strict";

	window.LayoutManager.transout = function (element, container, transOutType, transOutDuration, transOutDirection, callback) {
	    if (transOutType === "fadeIn") {
	        utils.hide(element);
	        utils.fadeIn(element,parseInt(transOutDuration), function() { callback(); });
	    } else if (transOutType === "fadeOut") {
	        utils.show(element);
	        utils.fadeOut(element,parseInt(transOutDuration), function() { callback(); });
	    } else if (transOutType === "fly") {
	        element.style.position = "absolute";
	        var position = {
	            top: parseInt(element.style.top),
	            left: parseInt(element.style.left)
	        };
	        var top = position.top;
	        var left = position.left;
	        if (transOutDirection.indexOf("S") >= 0) {
	            top = "-" + (utils.getElementHeight(element) + parseInt(container.style.top)) + "px";
	        }
	        if (transOutDirection.indexOf("N") >= 0) {
	            top = utils.getElementHeight(container.parentElement) + "px";
	        }
	        if (transOutDirection.indexOf("E") >= 0) {
	            left = "-" + (utils.getElementWidth(element) + parseInt(container.style.left)) + "px";
	        }
	        if (transOutDirection.indexOf("W") >= 0) {
	            left = utils.getElementWidth(container.parentElement) + "px";
	        }
	        //jQueryWebOs(element).animate({left: left, top: top}, parseInt(transOutDuration), 'swing', function() { callback(); });        
	        utils.animate(element,{left: left, top: top}, parseInt(transOutDuration),function() { callback(); });
	
	    }
	};
}());